﻿@model IEnumerable<ExploreApilkasiCuti.Models.MasterApproval>

@{
    ViewBag.Title = "Master Approval";
    Layout = "~/Views/Shared/_Layout.cshtml";
}
@section HeadLibrary{
    <!-- DataTables -->
    <link rel="stylesheet" href="~/AdminLTE/plugins/datatables-bs4/css/dataTables.bootstrap4.min.css">
    <link rel="stylesheet" href="~/AdminLTE//plugins/datatables-responsive/css/responsive.bootstrap4.min.css">
    <!-- SweetAlert2 -->
    <link rel="stylesheet" href="~/AdminLTE/plugins/sweetalert2-theme-bootstrap-4/bootstrap-4.min.css">
    <!-- Toastr -->
    <link rel="stylesheet" href="~/AdminLTE/plugins/toastr/toastr.min.css">

    <!-- iCheck for checkboxes and radio inputs -->
    <link rel="stylesheet" href="~/AdminLTE/plugins/icheck-bootstrap/icheck-bootstrap.min.css">
    <!-- Bootstrap Color Picker -->
    <link rel="stylesheet" href="~/AdminLTE/plugins/bootstrap-colorpicker/css/bootstrap-colorpicker.min.css">
    <!-- Select2 -->
    <link rel="stylesheet" href="~/AdminLTE/plugins/select2/css/select2.min.css">
    <link rel="stylesheet" href="~/AdminLTE/plugins/select2-bootstrap4-theme/select2-bootstrap4.min.css">
    <!-- Bootstrap4 Duallistbox -->
    <link rel="stylesheet" href="~/AdminLTE/plugins/bootstrap4-duallistbox/bootstrap-duallistbox.min.css">
    <!-- Theme style -->
    <link rel="stylesheet" href="~/AdminLTE/dist/css/adminlte.min.css">
}
<style>
    .content-table {
        border-collapse: collapse;
        margin: 25px 0;
        min-width: 1000px;
        box-shadow: 0 0 20px rgba(0, 0, 0, 0.15);
        width: 100%;
    }

    /* if the browser window is at least 800px-s wide: */
    @@media screen and (min-width: 800px) {
        table {
            width: 90%;
        }
    }

    /* if the browser window is at least 1000px-s wide: */
    @@media screen and (min-width: 1000px) {
        table {
            width: 80%;
        }
    }

    .content-table thead tr {
        background-color: #10ad21;
        color: #ffffff;
        text-align: left;
    }

    .content-table tr, td {
        border: solid black 0.5px;
    }

    .content-table th, td {
        padding: 12px 10px;
        border: solid black 0.5px;
    }

    #dataMasterJabatan_filter .iconSearch {
        float: left;
        display: inline-block;
    }

    .help-block {
        color: red;
    }

@*    .has-error {
        color: red;
    }*@
</style>


<!-- Main content -->
<div class="card">
    <div class="card-header">
        <h3 class="card-title"> Master Data Approval</h3>
    </div>
    <!-- /.card-header -->
    <div class="card-body">
        <div class="row">
            <button type="button" class="btn btn-success" onclick="add_Approval()">
                <i class="fa fa-plus-circle fa"></i>  Tambah Data
            </button>
            <div class="mt-3 col-md-12"></div>
        </div>
        <table id="dataMasterApproval" class="table table-bordered table-striped table-hover" role="grid" aria-describedby="dataMasterApproval_info">
            <thead>
                <tr>
                    <th>
                        @Html.DisplayName("ID Approval")
                    </th>
                    <th>
                        @Html.DisplayName("Deskripsi")
                    </th>
                    <th>
                        @Html.DisplayName("Mandatory")
                    </th>
                    <th>
                        @Html.DisplayName("Finish")
                    </th>
                    <th>
                        @Html.DisplayName("Status")
                    </th>
                    <th>
                        @Html.DisplayName("Action")
                    </th>
                </tr>
            </thead>
            <tbody>
                <tr>
                </tr>
            </tbody>
        </table>

    </div>
    <!-- /.card-body -->
</div>


<!-- /.card -->
<!-- /.modal Add start -->
<div class="modal fade" id="modal_form" role="dialog" data-keyboard="true" data-backdrop="static">
    <div class="modal-dialog modal-lg">
        <div class="modal-content">
            <div class="modal-header">
                <h4 class="modal-title">Data Approval</h4>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <div class="card card-primary">
                <!-- form start -->
                <form action="#" id="form" class="form-horizontal" enctype="multipart/form-data">
                    <div class="card-body">
                        <div class="form-group">
                            <label for="id_approval" class="col-md-4">ID Approval</label>
                            <input type="text" class="form-control" id="id_approval" placeholder="Masukkan ID Approval">
                            <span id="span_id_approval" class="help-block"></span>
                        </div>
                        <div class="form-group">
                            <label for="nama_approval" class="col-md-4">Deskripsi</label>
                            <input type="text" class="form-control" id="nama_approval" placeholder="Deskripsi">
                            <span id="span_nama_approval" class="help-block"></span>
                        </div>
                        <div class="form-group">
                            <label for="mandatory" class="col-md-4" control-label">Mandatory</label>
                            <select id="mandatory" class="form-control" style="height: 2.3em;width:250px;">
                                <option value="">-----Pilih-----</option>
                                <option value="true" selected>Yes</option>
                                <option value="false">No</option>
                            </select>
                            <span id="span_mandatory" class="help-block"></span>
                        </div>
                        <div class="form-group">
                            <label for="finish" class="col-md-4" control-label">Finish</label>
                            <select id="finish" class="form-control" style="height: 2.3em;width:250px;">
                                <option value="">-----Pilih-----</option>
                                <option value="true" selected>Yes</option>
                                <option value="false">No</option>
                            </select>
                            <span id="span_finish" class="help-block"></span>
                        </div>
                        <div class="form-group">
                            <label class="col-md-4">Pilih Karyawan</label>
                            <select class="select2" name="listKaryawan" multiple="multiple" id="listKaryawan" placeholder="Pilih Karyawan" style="width: 100%;">
                            </select>
                            <span id="span_id_listKaryawan" class="help-block"></span>
                        </div>
                        <div class="form-group">
                            <label for="SelectStatus" class="col-md-4" control-label">Status</label>
                            <select id="SelectStatus" class="form-control" style="height: 2.3em;width:250px;">
                                <option value="">-----Pilih Status-----</option>
                                <option value="Aktif" selected>Aktif</option>
                                <option value="Tidak Aktif">Tidak Aktif</option>
                            </select>
                            <span id="span_SelectStatus" class="help-block"></span>
                        </div>
                    </div>
                    <!-- /.card-body -->
                    <div class="card-footer d-flex">
                        <button type="button" id="btnSave" class="btn btn-primary mx-auto" style="width:35%">Simpan Data</button>
                        <button type="button" class="btn btn-danger mx-auto" data-dismiss="modal" style="width:35%">Batalkan</button>
                    </div>
                </form>
            </div>
        </div>
        <!-- /.modal-content -->
    </div>
    <!-- /.modal-dialog -->
</div>
<!-- /.modal Add end -->
<!-- /.modal Detail start -->
<div class="modal fade" id="modal_detail" role="dialog" data-keyboard="true" data-backdrop="static">
    <div class="modal-dialog modal-lg">
        <div class="modal-content">
            <div class="modal-header">
                <h4 class="modal-title">Data Approval</h4>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <div class="card card-primary">
                <!-- form start -->
                <form action="#" id="form_detail" class="form-horizontal" enctype="multipart/form-data">
                    <div class="card-body">
                                <div class="form-group">
                                    <label for="id_approval_dtl" class="col-md-4">ID Approval</label>
                                    <input type="text" class="form-control" id="id_approval_dtl" placeholder="">
                                    <span class="help-block"></span>
                                </div>
                                <div class="form-group">
                                    <label for="nama_approval_dtl" class="col-md-4">Deskripsi</label>
                                    <input type="text" class="form-control" id="nama_approval_dtl" placeholder="">
                                    <span class="help-block"></span>
                                </div>
                                <div class="form-group">
                                    <label for="mandatory_dtl" class="col-md-4" control-label">Mandatory</label>
                                    <select id="mandatory_dtl" class="form-control" style="height: 2.3em;width:250px;">
                                        <option value="">-----Pilih-----</option>
                                        <option value="true">Yes</option>
                                        <option value="false">No</option>
                                    </select>
                                    <span class="help-block"></span>
                                </div>
                                <div class="form-group">
                                    <label for="finish_dtl" class="col-md-4" control-label">Finish</label>
                                    <select id="finish_dtl" class="form-control" style="height: 2.3em;width:250px;">
                                        <option value="">-----Pilih-----</option>
                                        <option value="true">Yes</option>
                                        <option value="false">No</option>
                                    </select>
                                    <span class="help-block"></span>
                                </div>
                                <div class="form-group">
                                    <label class="col-md-4">List Karyawan</label>
                                    <select class="select2" name="listKaryawan_dtl" multiple="multiple" id="listKaryawan_dtl" placeholder="Pilih Karyawan" style="width: 100%;">
                                    </select>
                                    <span class="help-block"></span>
                                </div>
                                <div class="form-group">
                                    <label for="SelectStatus_dtl" class="col-md-4" control-label">Status</label>
                                    <select id="SelectStatus_dtl" class="form-control" style="height: 2.3em;width:250px;" disabled>
                                        <option value="">-----Pilih-----</option>
                                        <option value="Aktif">Aktif</option>
                                        <option value="Tidak Aktif">Tidak Aktif</option>
                                    </select>
                                </div>
                    </div>
                    <!-- /.card-body -->
                    <div class="card-footer">
                        <button type="button" class="btn btn-primary" data-dismiss="modal">Close</button>
                    </div>
                </form>
            </div>
        </div>
        <!-- /.modal-content -->
    </div>
    <!-- /.modal-dialog -->
</div>
<!-- /.modal Detail end -->


@section BodyLibrary{
    <!-- DataTables -->
    <script src="@Url.Content("~/AdminLTE/plugins/datatables/jquery.dataTables.min.js")"></script>
    <script src="@Url.Content("~/AdminLTE/plugins/datatables-bs4/js/dataTables.bootstrap4.min.js")"></script>
    <script src="@Url.Content("~/AdminLTE/plugins/datatables-responsive/js/dataTables.responsive.min.js")"></script>
    <script src="@Url.Content("~/AdminLTE/plugins/datatables-responsive/js/responsive.bootstrap4.min.js")"></script>
    <!-- SweetAlert2 -->
    <script src="@Url.Content("~/AdminLTE/plugins/sweetalert2/sweetalert2.min.js")"></script>
    <!-- Toastr -->
    <script src="@Url.Content("~/AdminLTE/plugins/toastr/toastr.min.js")"></script>
    <!-- DataRender -->
    <script src="@Url.Content("~/AdminLTE/plugins/dataRender/dateTime.js")"></script>
    <script src="@Url.Content("~/AdminLTE/plugins/jsgrid/demos/db.js")"></script>
    <script src="@Url.Content("~/AdminLTE/plugins/jsgrid/jsgrid.min.js")"></script>
    <!-- Select2 -->
    <script src="@Url.Content("~/AdminLTE/plugins/select2/js/select2.full.min.js")"></script>
    <!-- Bootstrap Switch -->
    <script src="@Url.Content("~/AdminLTE/plugins/bootstrap-switch/js/bootstrap-switch.min.js")"></script>
    <!-- bootstrap color picker -->
    <script src="@Url.Content("~/AdminLTE/plugins/bootstrap-colorpicker/js/bootstrap-colorpicker.min.js")"></script>
    <!-- Select2 -->
    <script src="~/AdminLTE/plugins/select2/js/select2.full.min.js"></script>

}

@section AdditionalScript{
    <script>
        var save_method;
        var rowId;
        var rowName;
        var masterApprovalTable;
        var selectKaryawan = new Array();
        var listkaryawan = new Array();
        var saved_message = '';

        jQuery(document).ready(function ($) {
                masterApprovalTable = $("#dataMasterApproval").DataTable({
                    "responsive": true,
                    "autoWidth": false,
                    "ajax": {
                        "url": '@Url.Action("GetDatatableAll")',
                        "type": "POST",
                        "datatype": "JSON"
                    },
                    "columns": [
                        { "data": "id_approval", "name": "id_approval" },
                        { "data": "nama_approval", "name": "nama_approval" },
                        { "data": "mandatory", "name": "mandatory" },
                        { "data": "finish", "name": "finish" },
                        { "data": "status", "name": "status" },
                        {
                            data: null, render: function (data, type, row) {
                                return '<button type="button" data-toggle="modal" class="btn btn-sm btn-icon btn-icon rounded-circle bg-gradient-primary waves-effect waves-light" style="margin-right: 5px;" onclick="view_detail(\'' + data.id_approval + '\')"><i class="fas fa-eye"></i></button> <button type="button" class="btn btn-sm btn-icon btn-icon rounded-circle bg-gradient-primary waves-effect waves-light" style="margin-right: 5px;" onclick="edit_Approval(\'' + data.id_approval + '\')"><i class="fas fa-edit"></i></button><button type="button" class="btn btn-sm btn-icon btn-icon rounded-circle bg-gradient-danger waves-effect waves-light" onclick="deleteApproval(\'' + data.id_approval + '\')"><i class="fa fa-trash-alt"></i></button>'
                            }

                        },
                    ],

                });

            loadDataSelect2();
        });

        function loadDataSelect2() {

            $.ajax({
                url: '@Url.Content("~/MasterApproval/GetDataKaryawan")',
                type: 'POST',
                dataType: 'json',
                delay: 250,
                processResults: function (data) {
                    return {
                        results: $.map(data['data'], function (item) {
                            return {
                                text: item.nama,
                                id: item.id_karyawan
                            }
                        })
                    };
                }
            }).then(
                function (response) {
                    $('#listKaryawan').select2({
                        multiple: true,
                        allowClear: true,
                        placeholder: '- Pilih Karyawan -',
                        width: '100%',
                        //theme: 'bootstrap4',
                        data: $.map(response.data, function (item) {
                            return {
                                text: item.nama,
                                id: item.id_karyawan
                            }
                        })
                    });
                }
            );

            $.ajax({
                url: '@Url.Content("~/MasterApproval/GetDataKaryawan")',
                type: 'POST',
                dataType: 'json',
                delay: 250,
                processResults: function (data) {
                    return {
                        results: $.map(data['data'], function (item) {
                            return {
                                text: item.nama,
                                id: item.id_karyawan
                            }
                        })
                    };
                }
            }).then(
                function (response) {
                    $('#listKaryawan_dtl').select2({
                        multiple: true,
                        allowClear: true,
                        placeholder: '- Pilih Karyawan -',
                        width: '100%',
                        //theme: 'bootstrap4',
                        data: $.map(response.data, function (item) {
                            return {
                                text: item.nama,
                                id: item.id_karyawan
                            }
                        }),
                        disabled: true
                    });
                }
            );
        }
        @*
        $('.select2').select2();
        //$('.listKaryawan').parents('.bootbox').removeAttr('tabindex');
        $('#listKaryawan').select2({
            dropdownParent: ("#modal_form"),
            multiple: true,
            placeholder: "- Pilih Karyawan -",
            allowClear: true,
            width: '100%',
            //theme: //'bootstrap4',
            ajax: {
                url: '@Url.Content("~/MasterApproval/GetDataKaryawan")',
                type: 'POST',
                dataType: 'json',
                delay: 250,
                processResults: function (data) {
                    return {
                        results: $.map(data["data"], function (item) {
                            return {
                                text: item.nama,
                                id: item.id_karyawan,
                                //selected: "true"
                            }
                        })
                    };
                }
            }
        });


        $('#listKaryawan_dtl').select2({
            dropdownParent: ("#modal_detail"),
            multiple: true,
           // placeholder: "- Pilih Karyawan -",
            allowClear: true,
            width: '100%',
           // theme: 'bootstrap4',
            ajax: {
                url: '@Url.Content("~/MasterApproval/GetDataKaryawan")',
                type: 'POST',
                dataType: 'json',
                delay: 250,
                processResults: function (data) {
                    return {
                        results: $.map(data["data"], function (item) {
                            return {
                                text: item.nama,
                                id: item.id_karyawan,
                                //selected: "true"
                            }
                        })
                    };
                }
            },
            disabled: true
        });
         *@

        $('#btnSave').on('click', function () {
            saved_message = '';
            var validate = true;
            var url;
            $(".err-cutiBulanan").css('color: black');
            $(".form-group").removeClass('has-error');
            $(".help-block").empty()

            @*var mailformat = /^[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+@[a-zA-Z0-9-]+(?:\.[a-zA-Z0-9-]+)*$/;*@
            if ($('#id_approval').val() == "") {
                $('#id_approval').parent().addClass('has-error');
                $('#id_approval').next().text('ID Approval Harus diisi');
                validate = false;
            }
            if ($('#nama_approval').val() == "") {
                $('#nama_approval').parent().addClass('has-error');
                $('#nama_approval').next().text('Nama Approval Harus diisi');
                validate = false;
            }
            if ($('#mandatory').val() == "") {
                $('#mandatory').parent().addClass('has-error');
                $('#mandatory').next().text('Mandatory Approval Harus diisi');
                validate = false;
            }
            if ($('#finish').val() == "") {
                $('#finish').parent().addClass('has-error');
                $('#finish').next().text('Finish Approval Harus diisi');
                validate = false;
            }
            if ($('#listKaryawan').val() == "") {
                $('#span_id_listKaryawan').text('Karyawan Harus diisi');
                validate = false;
            }
            if ($('#SelectStatus').val() == "") {
                $('#span_SelectStatus').text('Status Harus diisi');
                validate = false;
            }

            if (!validate) {
                return;
            }

            listkaryawan = $("#listKaryawan").val();

            if (save_method == 'add') {
                //add to DB Approval
                $.ajax({
                    url: '@Url.Action("Create")',
                    method: "POST",
                    dataType: "JSON",
                    data: {
                        "id_approval": $('#id_approval').val(),
                        "nama_approval": $('#nama_approval').val(),
                        "mandatory": $('#mandatory').val(),
                        "finish": $('#finish').val(),
                        "status": $('#SelectStatus').val(),
                    },
                    beforeSend: function () {
                        Swal.fire({
                            title: 'Processing...',
                            html: "Saving Data.",
                            allowOutsideClick: false,
                            onBeforeOpen: () => {
                                Swal.showLoading()
                            }
                        });
                    },
                    success: function (result) {
                        //Swal.close();
                        if (result.metaData.code === '200') {
                            saved_message = 'Data berhasil ditambahkan.';
                            deletekaryawanApproval($('#id_approval').val());
                           // addkaryawanApproval_2(listkaryawan);
                            //$('#modal_form').modal('hide');
                            //masterApprovalTable.ajax.reload();
                           // return toastr.success('Data berhasil ditambahkan.', 'Success!', { "timeOut": 5000 });
                        } else {
                            wal.close();
                            return toastr.warning(result.metaData.message, 'Sorry!', { "timeOut": 5000 });
                        }
                    },
                    error: function (eventError, textStatus, errorThrown) {
                        return toastr.error(formatErrorMessage(eventError, errorThrown), 'Failed!', { "timeOut": 5000 });
                    }
                });


            }//end add
            else if (save_method == 'update') {

                $.ajax({
                    url: '@Url.Action("Update")',
                    method: "POST",
                    dataType: "JSON",
                    data: {
                        "id_approval": $('#id_approval').val(),
                        "nama_approval": $('#nama_approval').val(),
                        "mandatory": $('#mandatory').val(),
                        "finish": $('#finish').val(),
                        "status": $('#SelectStatus').val(),
                    },
                    beforeSend: function () {
                        Swal.fire({
                            title: 'Processing...',
                            html: "Saving Data.",
                            allowOutsideClick: false,
                            onBeforeOpen: () => {
                                Swal.showLoading()
                            }
                        });
                    },
                    success: function (result) {
                        //Swal.close();
                        if (result.metaData.code === '200') {
                            saved_message = 'Data berhasil diperbarui.';
                            deletekaryawanApproval($('#id_approval').val());

                           @* $('#modal_form').modal('hide');
                            masterApprovalTable.ajax.reload();
                            return toastr.success('Data berhasil diperbarui.', 'Success!', { "timeOut": 5000 });*@
                        } else {
                            Swal.close();
                            return toastr.warning(result.metaData.message, 'Sorry!', { "timeOut": 5000 });
                        }
                    },
                    error: function (eventError, textStatus, errorThrown) {
                        return toastr.error(formatErrorMessage(eventError, errorThrown), 'Failed!', { "timeOut": 5000 });
                    }
                });
            }

        });


        function view_detail(id_approval) {

            getKaryawanApproval(id_approval);
            $('#id_approval_dtl').attr('readonly', true);
            $("#nama_approval_dtl").attr("readonly", true);
            $('#mandatory_dtl').prop('disabled', 'disabled');
            $('#finish_dtl').prop('disabled', 'disabled');
            $('listKaryawan_dtl').prop('disabled', true);
            $('SelectStatus_dtl').prop('disabled', 'disabled');
            $('.modal-title').text('Detail Approval');
            $.ajax({
                url: '@Url.Action("GetDataByID")' + "/" + id_approval,
                    method: "POST",
                    dataType: "JSON",
                    beforeSend: function () {
                        Swal.fire({
                            title: 'Loading...',
                            html: "Loading Data.",
                            allowOutsideClick: false,
                            onBeforeOpen: () => {
                                Swal.showLoading()
                            }
                        });
                    },
                    success: function (result) {
                        if (result.metaData.code === '200') {
                            Swal.close();
                            $('#id_approval_dtl').val(result.response[0].id_approval);
                            $('#nama_approval_dtl').val(result.response[0].nama_approval).trigger('change');
                            $('#mandatory_dtl').val(""+result.response[0].mandatory+"").trigger('change');
                            $('#finish_dtl').val("" + result.response[0].finish + "").trigger('change');
                            $('#SelectStatus_dtl').val(result.response[0].status).trigger('change');
                            getSelectedKaryawan('#listKaryawan_dtl');
                            $('#modal_detail').modal('show');

                        } else {
                            return toastr.warning(result.metaData.message, 'Sorry!', { "timeOut": 5000 });
                        }
                    },
                    error: function (eventError, textStatus, errorThrown) {
                        return toastr.error(formatErrorMessage(eventError, errorThrown), 'Failed!', { "timeOut": 5000 });
                    }
                });
        }


        function edit_Approval(id_approval) {

            getKaryawanApproval(id_approval);
            $('.modal-title').text('Edit Approval');
            save_method = 'update';
            $("#id_approval").attr("readonly", true);

            $.ajax({
                url: '@Url.Action("GetDataByID")' + "/" + id_approval,
                    method: "POST",
                    dataType: "JSON",
                    beforeSend: function () {
                        Swal.fire({
                            title: 'Loading...',
                            html: "Loading Data.",
                            allowOutsideClick: false,
                            onBeforeOpen: () => {
                                Swal.showLoading()
                            }
                        });
                    },
                    success: function (result) {
                        if (result.metaData.code === '200') {
                            Swal.close();
                            $('#id_approval').val(result.response[0].id_approval);
                            $('#nama_approval').val(result.response[0].nama_approval).trigger('change');
                            $('#mandatory').val(""+result.response[0].mandatory+"").trigger('change');
                            $('#finish').val("" + result.response[0].finish + "").trigger('change');
                            $('#SelectStatus').val(result.response[0].status).trigger('change');
                            getSelectedKaryawan('#listKaryawan');
                            loadDataSelect2();
                            $('#modal_form').modal('show');

                        } else {
                            return toastr.warning(result.metaData.message, 'Sorry!', { "timeOut": 5000 });
                        }
                    },
                    error: function (eventError, textStatus, errorThrown) {
                        return toastr.error(formatErrorMessage(eventError, errorThrown), 'Failed!', { "timeOut": 5000 });
                    }
                });
        }

        function add_Approval() {
            save_method = 'add';
            $('#form')[0].reset();
            $('#id_approval').attr('readonly', false);
            $('#listKaryawan').val(null).trigger('change');
            $('#modal_form').modal('show'); // show bootstrap modal
            $('.modal-title').text('Add Approval'); // Set Title to Bootstrap modal title
        }

        function deleteApproval(id_approval) {
            Swal.fire({
                title: 'Perhatian',
                text: "Apakah anda Yakin menghapus data dengan ID " + id_approval+" ?" ,
                type: 'warning',
                showCancelButton: true,
                confirmButtonColor: '#3085d6',
                cancelButtonColor: '#d33',
                confirmButtonText: 'Hapus Data',
                confirmButtonClass: 'btn btn-primary',
                cancelButtonClass: 'btn btn-danger ml-1',
                showLoaderOnConfirm: true,
                buttonsStyling: false,
                preConfirm: (delete_part) => {
                    return fetch ('@Url.Action("DeleteKaryawanApproval_2")' + "/" + id_approval, {           @*('@Url.Action("DeleteApproval")' + "/" + id_approval, {*@
                        method: 'POST'
                    }).then(response => {
                        if (!response.ok) {
                            return toastr.error(response.statusText, 'Failed!', { "timeOut": 5000 });
                        }
                        return response.json();
                    }).then(result => {
                        if (result.metaData.code === '200') {
                            deleteApproval_2(id_approval);
                            masterApprovalTable.ajax.reload();
                            //return toastr.success('Data has been deleted.', 'Success!', { "timeOut": 5000 });
                        } else {
                            return toastr.warning(result.metaData.message, 'Sorry!', { "timeOut": 5000 });
                        }
                    }).catch(error => {
                        Swal.showValidationMessage(
                            `Request failed: ${error}`
                        )
                    })
                },
                allowOutsideClick: () => !Swal.isLoading()
            });
        }

        function deletekaryawanApproval(id_approval) {
            $.ajax({
                    contentType: 'application/json; charset=utf-8',
                    url:  '@Url.Action("DeleteKaryawanApproval")' + "/" + id_approval,
                    method: "POST",
                    dataType: "JSON",
                    success: function (result) {
                        if (result.metaData.code === '200') {
                            masterApprovalTable.ajax.reload();
                            addkaryawanApproval_2(listkaryawan);
                            //return toastr.success('Data has been deleted.', 'Success!', { "timeOut": 5000 });

                        } else {
                            //return toastr.warning(result.metaData.message, 'Sorry!', { "timeOut": 5000 });
                        }
                    },
                    error: function (eventError, textStatus, errorThrown) {
                        //return toastr.error(formatErrorMessage(eventError, errorThrown), 'Failed!', { "timeOut": 5000 });
                    }
             });
        }

        function addkaryawanApproval_1(listkaryawan) { //add per row
            var data1 = [{
                "id_karyawan_approval": "APPHRD02",
                "id_approval": "APPHRD02",
                "id_karyawan": "id01",

            },
            {
                "id_karyawan_approval": "APPHRD02_id02",
                "id_approval": "APPHRD02",
                "id_karyawan": "id02",
            }
            ];

            var data5 = JSON.stringify(data1);

             //add to DB Approval Karyawan
            for (var item in listkaryawan) {
                $.ajax({
                    ContentType: 'application/json; charset=utf-8',
                    url: '@Url.Content("~/MasterKaryawanApproval/InsertList")',
                    method: "POST",
                    dataType: "JSON",
                    data: JSON.stringify(data1),
                    beforeSend: function () {
                        Swal.fire({
                            title: 'Processing...',
                            html: "Saving Data.",
                            allowOutsideClick: false,
                            onBeforeOpen: () => {
                                Swal.showLoading()
                            }
                        });
                    },
                    success: function (result) {
                        Swal.close();
                        if (result.metaData.code === '200') {
                            $('#modal_form').modal('hide');
                            masterApprovalTable.ajax.reload();
                            //masterKaryawanTable.clear().draw();
                            toastr.success('Data berhasil ditambahkan.' + listkaryawan[item], 'Success!', { "timeOut": 5000 });

                            //return toastr.success('Data berhasil ditambahkan.', 'Success!', { "timeOut": 5000 });

                        } else {
                            //return toastr.warning(result.metaData.message, 'Sorry!', { "timeOut": 5000 });
                        }
                    },
                    error: function (eventError, textStatus, errorThrown) {
                        return toastr.error(formatErrorMessage(eventError, errorThrown), 'Failed!', { "timeOut": 5000 });
                    }
                });
            }
        }


        function addkaryawanApproval_2(listkaryawan) { //add per row
             //add to DB Approval Karyawan
            
            for (let a = 0; a < listkaryawan.length; a++) {
                console.log("add : " + listkaryawan[a]);

                $.ajax({
                    //contentType: 'application/json; charset=utf-8',
                    url: '@Url.Content("~/MasterKaryawanApproval/Create")',
                    method: "POST",
                    dataType: "JSON",
                    data: {
                        "id_karyawan_approval": $('#id_approval').val() + "_" + listkaryawan[a],
                        "id_approval": $('#id_approval').val(),
                        "id_karyawan": listkaryawan[a],
                    },

                    success: function (result) {
                       // Swal.close();
                        if (result.metaData.code === '200') {
                            //$('#modal_form').modal('hide');
                            //masterApprovalTable.ajax.reload();
                            //return toastr.warning(result.metaData.message, 'Success! :data' + listkaryawan[a], { "timeOut": 5000 });
                        } else {
                            return toastr.warning(result.metaData.message, 'Sorry!:data' + listkaryawan[a], { "timeOut": 5000 });
                        }
                        if (a == (listkaryawan.length - 1)) {
                            masterApprovalTable.ajax.reload();
                            setTimeout(function () {
                                Swal.close();
                                $('#modal_form').modal('hide');
                                toastr.success(saved_message, 'Success!', { "timeOut": 5000 });
                            }, 500);
                        }
                    },
                    error: function (eventError, textStatus, errorThrown) {
                        return toastr.error(formatErrorMessage(eventError, errorThrown), 'Failed!', { "timeOut": 5000 });
                    }
                });
            }
           

        }


        function getKaryawanApproval(id_approval) {
            selectKaryawan = [];
            selectNamaKaryawan = [];
            console.log(selectKaryawan);

             $.ajax({
                 url: '@Url.Content("~/MasterKaryawanApproval/GetKaryawanApprovalByIdApproval")' + "/" + id_approval,
                    method: "POST",
                    dataType: "JSON",
                    beforeSend: function () {
                        Swal.fire({
                            title: 'Loading...',
                            html: "Loading Data.",
                            allowOutsideClick: false,
                            onBeforeOpen: () => {
                                Swal.showLoading()
                            }
                        });
                    },
                    success: function (result) {
                        if (result.metaData.code === '200') {

                            Swal.close();
                            selectKaryawan = [];
                            selectNamaKaryawan = [];
                            if (result.response.length > 0) {
                                for (let a = 0; a < result.response.length; a++) {
                                    selectKaryawan.push(result.response[a].id_karyawan);
                                    selectNamaKaryawan.push(result.response[a].nama);
                                }
                            } else {
                                selectKaryawan = [];
                                selectNamaKaryawan = [];
                            }

                            console.log(result.response.length);

                        } else {
                           // return toastr.warning(result.metaData.message, 'Sorry!', { "timeOut": 5000 });
                        }
                    },
                    error: function (eventError, textStatus, errorThrown) {
                        //return toastr.error(formatErrorMessage(eventError, errorThrown), 'Failed!', { "timeOut": 5000 });
                    }
                });

        }

        function getSelectedKaryawan(id_select) {

            $(id_select).val(null).trigger('change');
            $(id_select).text(null).trigger('change');
            var newOption;
            for (let a = 0; a < selectKaryawan.length; a++) {

                newOption = new Option(selectNamaKaryawan[a], selectKaryawan[a], true, true);
                $(id_select).append(newOption).trigger('change');

            }
        }

        function deleteApproval_2(id_approval) {
            $.ajax({
                    contentType: 'application/json; charset=utf-8',
                    url:  '@Url.Action("DeleteApproval")' + "/" + id_approval,
                    method: "POST",
                    dataType: "JSON",
                    success: function (result) {
                        //Swal.close();
                        if (result.metaData.code === '200') {
                            $('#modal_form').modal('hide');
                            masterApprovalTable.ajax.reload();
                            return toastr.success('Data has been deleted.', 'Success!', { "timeOut": 5000 });

                        } else {
                            //return toastr.warning(result.metaData.message, 'Sorry!', { "timeOut": 5000 });
                        }
                    },
                    error: function (eventError, textStatus, errorThrown) {
                        //return toastr.error(formatErrorMessage(eventError, errorThrown), 'Failed!', { "timeOut": 5000 });
                    }
             });
        }

    </script>


}

